Module: selenium-webdriver/ie
View Source

# class Options

Class for managing IEDriver specific options.

## Instance Methods

### addArguments(var_args)code »

Specifies command-line switches to use when launching Internet Explorer. This is only valid when used with `#forceCreateProcessApi`.

Parameters

var_args`...(string|Array<string>)`

  The arguments to add.

Returns

`Options`

  A self reference.

### browserAttachTimeout(timeout)code »

Configures the timeout, in milliseconds, that the driver will attempt to located and attach to a newly opened instance of Internet Explorer. The default is zero, which indicates waiting indefinitely.

Parameters

timeout`number`

  How long to wait for IE.

Returns

`Options`

  A self reference.

### enableElementCacheCleanup(enable)code »

Configures whether the driver should attempt to remove obsolete WebElements from its internal cache on page navigation (true by default). Disabling this option will cause the driver to run with a larger memory footprint.

Parameters

enable`boolean`

  Whether to enable element reference cleanup.

Returns

`Options`

  A self reference.

### enablePersistentHover(enable)code »

Configures whether to enable persistent mouse hovering (true by default). Persistent hovering is achieved by continuously firing mouse over events at the last location the mouse cursor has been moved to.

Parameters

enable`boolean`

  Whether to enable persistent hovering.

Returns

`Options`

  A self reference.

### ensureCleanSession(cleanSession)code »

Configures whether to clear the cache, cookies, history, and saved form data before starting the browser. Using this capability will clear session data for all running instances of Internet Explorer, including those started manually.

Parameters

cleanSession`boolean`

  Whether to clear all session data on startup.

Returns

`Options`

  A self reference.

### forceCreateProcessApi(force)code »

Configures whether to launch Internet Explorer using the CreateProcess API. If this option is not specified, IE is launched using IELaunchURL, if available. For IE 8 and above, this option requires the TabProcGrowth registry value to be set to 0.

Parameters

force`boolean`

  Whether to use the CreateProcess API.

Returns

`Options`

  A self reference.

### ignoreZoomSetting(ignore)code »

Indicates whether to skip the check that the browser's zoom level is set to 100%.

Parameters

ignore`?`

Returns

`Options`

  ore Whether to ignore the browser's zoom level settings.

### initialBrowserUrl(url)code »

Sets the initial URL loaded when IE starts. This is intended to be used with `#ignoreProtectedModeSettings` to allow the user to initialize IE in the proper Protected Mode zone. Setting this option may cause browser instability or flaky and unresponsive code. Only "best effort" support is provided when using this option.

Parameters

url`string`

  The initial browser URL.

Returns

`Options`

  A self reference.

### introduceFlakinessByIgnoringProtectedModeSettings(ignoreSettings)code »

Whether to disable the protected mode settings check when the session is created. Disbling this setting may lead to significant instability as the browser may become unresponsive/hang. Only "best effort" support is provided when using this capability.

For more information, refer to the IEDriver's required system configuration.

Parameters

ignoreSettings`boolean`

  Whether to ignore protected mode settings.

Returns

`Options`

  A self reference.

### requireWindowFocus(require)code »

Configures whether to require the IE window to have input focus before performing any user interactions (i.e. mouse or keyboard events). This option is disabled by default, but delivers much more accurate interaction events when enabled.

Parameters

require`boolean`

  Whether to require window focus.

Returns

`Options`

  A self reference.

### setExtractPath(path)code »

Sets the path of the temporary data directory to use.

Parameters

path`string`

  The log file path.

Returns

`Options`

  A self reference.

### setHost(host)code »

Sets the IP address of the driver's host adapter.

Parameters

host`string`

  The IP address to use.

Returns

`Options`

  A self reference.

### setLogFile(file)code »

Sets the path to the log file the driver should log to.

Parameters

file`?`

Returns

`Options`

  A self reference.

### setLogLevel(level)code »

Sets the IEDriverServer's logging level.

Parameters

level`string`

  The logging level.

Returns

`Options`

  A self reference.

### setProxy(proxy)code »

Sets the proxy settings for the new session.

Parameters

proxy`selenium-webdriver.ProxyConfig`

  The proxy configuration to use.

Returns

`Options`

  A self reference.

### silent(silent)code »

Sets whether the driver should start in silent mode.

Parameters

silent`boolean`

  Whether to run in silent mode.

Returns

`Options`

  A self reference.

### toCapabilities(opt_capabilities)code »

Converts this options instance to a `webdriver.Capabilities` object.

Parameters

opt_capabilities`?Capabilities=`

  The capabilities to merge these options into, if any.

Returns

`webdriver.Capabilities`

  The capabilities.

### usePerProcessProxy(enable)code »

Configures whether proxies should be configured on a per-process basis. If not set, setting a proxy will configure the system proxy. The default behavior is to use the system proxy.

Parameters

enable`boolean`

  Whether to enable per-process proxy settings.

Returns

`Options`

  A self reference.

## Static Functions

### Options.fromCapabilities(capabilities)code »

Extracts the IEDriver specific options from the given capabilities object.

Parameters

capabilities`webdriver.Capabilities`

  The capabilities object.

Returns

`Options`

  The IEDriver options.